<?php

namespace App\Model;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;

class Page extends Content
{
	protected static function boot()
    {
        parent::boot(); // TODO: Change the autogenerated stub

        $type = ['page', 'join', 'partnership'];
        $map = [

        ];

        static::addGlobalScope('', function (Builder $builder) use ($type) {
            $builder->where('type', 'partnership')
            ->orWhere('type', 'page')
            ->orWhere('type', 'join');
        });

        // self::creating(function($model) use ($type, $map) {
        //     $model->type = $type;
        //     foreach($map as $k=>$v){
        //         $model->$v = request()->$k;
        //     }
        // });

        // self::updating(function($model) use ($type, $map) {
        //     $model->type = $type;
        // });
        // self::retrieved(function($model) use ($map) {
        //     foreach($map as $k=>$v){
        //         $model->$k = $model->$v;
        //     }
        // });

    }

    public function childs()
    {
        return $this->hasMany('App\Model\Page', 'parent_id');
    }

    public function parent()
    {
        return $this->belongsTo('App\Model\Page', 'parent_id');
    }
}
